package javax.swing.plaf.multi;

import javax.accessibility.Accessible;
import java.awt.Dimension;
import javax.swing.JComponent;
import java.awt.Graphics;
import javax.swing.JSplitPane;
import javax.swing.plaf.ComponentUI;
import java.util.Vector;
import javax.swing.plaf.SplitPaneUI;

public class MultiSplitPaneUI extends SplitPaneUI
{
    protected Vector uis;
    
    public MultiSplitPaneUI() {
        this.uis = new Vector();
    }
    
    public ComponentUI[] getUIs() {
        return MultiLookAndFeel.uisToArray(this.uis);
    }
    
    @Override
    public void resetToPreferredSizes(JSplitPane splitPane) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(i)).resetToPreferredSizes(splitPane);
        }
    }
    
    @Override
    public void setDividerLocation(JSplitPane splitPane, int n) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(i)).setDividerLocation(splitPane, n);
        }
    }
    
    @Override
    public int getDividerLocation(JSplitPane splitPane) {
        int dividerLocation = ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(0)).getDividerLocation(splitPane);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(i)).getDividerLocation(splitPane);
        }
        return dividerLocation;
    }
    
    @Override
    public int getMinimumDividerLocation(JSplitPane splitPane) {
        int minimumDividerLocation = ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(0)).getMinimumDividerLocation(splitPane);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(i)).getMinimumDividerLocation(splitPane);
        }
        return minimumDividerLocation;
    }
    
    @Override
    public int getMaximumDividerLocation(JSplitPane splitPane) {
        int maximumDividerLocation = ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(0)).getMaximumDividerLocation(splitPane);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(i)).getMaximumDividerLocation(splitPane);
        }
        return maximumDividerLocation;
    }
    
    @Override
    public void finishedPaintingChildren(JSplitPane splitPane, Graphics graphics) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((SplitPaneUI)(SplitPaneUI)this.uis.elementAt(i)).finishedPaintingChildren(splitPane, graphics);
        }
    }
    
    @Override
    public boolean contains(JComponent component, int n, int n2) {
        int contains = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).contains(component, n, n2);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).contains(component, n, n2);
        }
        return contains;
    }
    
    @Override
    public void update(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).update(g, c);
        }
    }
    
    public static ComponentUI createUI(JComponent component) {
        MultiSplitPaneUI multiSplitPaneUI = new MultiSplitPaneUI();
        return MultiLookAndFeel.createUIs(multiSplitPaneUI, ((MultiSplitPaneUI)multiSplitPaneUI).uis, component);
    }
    
    @Override
    public void installUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).installUI(c);
        }
    }
    
    @Override
    public void uninstallUI(JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).uninstallUI(c);
        }
    }
    
    @Override
    public void paint(Graphics g, JComponent c) {
        for (int i = 0; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).paint(g, c);
        }
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        Dimension preferredSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getPreferredSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getPreferredSize(component);
        }
        return preferredSize;
    }
    
    @Override
    public Dimension getMinimumSize(JComponent component) {
        Dimension minimumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMinimumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMinimumSize(component);
        }
        return minimumSize;
    }
    
    @Override
    public Dimension getMaximumSize(JComponent component) {
        Dimension maximumSize = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getMaximumSize(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getMaximumSize(component);
        }
        return maximumSize;
    }
    
    @Override
    public int getAccessibleChildrenCount(JComponent component) {
        int accessibleChildrenCount = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChildrenCount(component);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChildrenCount(component);
        }
        return accessibleChildrenCount;
    }
    
    @Override
    public Accessible getAccessibleChild(JComponent component, int n) {
        Accessible accessibleChild = ((ComponentUI)(ComponentUI)this.uis.elementAt(0)).getAccessibleChild(component, n);
        for (int i = 1; i < this.uis.size(); ++i) {
            ((ComponentUI)(ComponentUI)this.uis.elementAt(i)).getAccessibleChild(component, n);
        }
        return accessibleChild;
    }
}
